//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <assert.h>
#pragma hdrstop

#include "Console.h"
#include "global.h"
TConsoleApp *ConsoleApp;
//---------------------------------------------------------------------------
int __fastcall RunConsoleApp(const AnsiString &Cmdline, TStrings *Output,
    WORD ShowCmd, bool *Cancel, TProgressBar *ProgressBar)
{
   ConsoleApp = new TConsoleApp(Cmdline,Output,ShowCmd);
   ConsoleApp->progressbar = ProgressBar;
   ConsoleApp->cancel = Cancel;
   int ok=ConsoleApp->Run();
   delete ConsoleApp;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TConsoleApp::TConsoleApp(const AnsiString &Cmdline, TStrings *Output, WORD ShowCmd)
{
   progressbar = NULL;
   showcmd = ShowCmd;
   cmdline = Cmdline;
   output = Output;
   creatpipe = false;
   creatproc = false;
   exitproc = false;
   exitwait = false;
   exitcode = 0;
   cancel = NULL;
}
//---------------------------------------------------------------------------
__fastcall TConsoleApp::~TConsoleApp()
{
}
//---------------------------------------------------------------------------
// used by RunConsoleApp {below}
bool __fastcall TConsoleApp::readfile(HANDLE hReadPipe)
{
   static char buf[1024];
   static AnsiString incomingline;
   unsigned long len,bufsize = sizeof(buf)-1;
   ReadFile(hReadPipe,buf,bufsize,&len, NULL);
   if (len>1)
   {
      for (unsigned i=0; i<len; i++)
      {
         if (buf[i]!='\0' && buf[i]!='\n' && buf[i]!='\r')
            incomingline += String(buf[i]);
         if (buf[i]=='\n')
         {
            output->Add(incomingline);
            incomingline.SetLength(0);
         }
      }
   }
   if (len<bufsize) return false;
   return true;
}
//---------------------------------------------------------------------------
/*
void __fastcall TConsoleApp::Run()
{
   STARTUPINFO sui;
   PROCESS_INFORMATION pi;
   SECURITY_ATTRIBUTES sa;
   HANDLE hReadPipe, hWritePipe;
   // setup the stdout
   // first create the sec attrib
   sa.nLength = sizeof (SECURITY_ATTRIBUTES);
   sa.lpSecurityDescriptor = NULL;
   sa.bInheritHandle = true;
   // create pipe handles
   CreatePipe(&hReadPipe, &hWritePipe, &sa, 2500000);
   if (hReadPipe == INVALID_HANDLE_VALUE || hWritePipe == INVALID_HANDLE_VALUE)
   {
      MessageBox(NULL,"Not a valid Handle for STDOUT",NULL,MB_OK|MB_ICONEXCLAMATION);
      return;
   }
   // setup the start up info
   memset(&sui, 0, sizeof(STARTUPINFO));
   sui.cb = sizeof (STARTUPINFO);
   sui.lpReserved = NULL;
   sui.lpDesktop = NULL;
   sui.lpTitle = NULL;
   sui.lpReserved2 = NULL;
   sui.cbReserved2 = 0;
   sui.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
   sui.wShowWindow = SW_MINIMIZE;
   sui.hStdOutput = hWritePipe;
   sui.hStdError = hWritePipe;
   if (!CreateProcess (NULL,
      cmdline.c_str(),   	// pointer to command line string
      NULL, 		// pointer to process security attributes, we don't need to inherit the handle
      NULL, 		// pointer to thread security attributes
      true,  		// handle inheritance flag
      0,  		   // creation flags
      NULL, 		// pointer to new environment block
      NULL, 		// pointer to current directory name
     &sui,   		// pointer to STARTUPINFO
     &pi 			// pointer to PROCESS_INFORMATION
   ))
   {
      MessageBox(NULL,"Could not create process", NULL, MB_OK | MB_ICONEXCLAMATION);
      return;
   }
   CloseHandle(pi.hThread);

   int ms=500;
   int done=0;
   DWORD bt,xcode;
   while (++done<30000)
   {
      Application->ProcessMessages();
      if (GetExitCodeProcess(pi.hProcess,&xcode) && xcode != STILL_ACTIVE) break;
      if (WaitForSingleObject(pi.hProcess,ms) != WAIT_TIMEOUT) break;
      while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
      {
         Application->ProcessMessages();
         readfile(hReadPipe);
      }
   }
   while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
   {
      Application->ProcessMessages();
      readfile(hReadPipe);
   }
   if (!unattended) MessageBeep(MB_OK);
   Sleep(1000);
   return;
}
*/
//---------------------------------------------------------------------------
long __fastcall TConsoleApp::Run()
{
   STARTUPINFO sui;
   PROCESS_INFORMATION pi;
   SECURITY_ATTRIBUTES sa;
   HANDLE hReadPipe, hWritePipe;
   // setup the stdout
   // first create the sec attrib
   sa.nLength = sizeof (SECURITY_ATTRIBUTES);
   sa.lpSecurityDescriptor = NULL;
   sa.bInheritHandle = true;
   // create pipe handles
   if ((creatpipe=CreatePipe(&hReadPipe, &hWritePipe, &sa, 2500000))==0)
   {
      output->Add("CreatePipe Error: "+GetLastErrorStr());
      return false;
   }
   if (hReadPipe==INVALID_HANDLE_VALUE || hWritePipe==INVALID_HANDLE_VALUE)
   {
      output->Add("CreatePipe Error: Not a valid Handle for STDIN/STDOUT");
      return false;
   }
   // setup the start up info
   memset(&sui, 0, sizeof(STARTUPINFO));
   sui.cb = sizeof (STARTUPINFO);
   sui.lpReserved = NULL;
   sui.lpDesktop = NULL;
   sui.lpTitle = NULL;
   sui.lpReserved2 = NULL;
   sui.cbReserved2 = 0;
   sui.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
   sui.wShowWindow = showcmd;
   sui.hStdOutput = hWritePipe;
   sui.hStdError = hWritePipe;
   if (!(creatproc=CreateProcess(NULL,
      cmdline.c_str(),   	// pointer to command line string
      NULL, 		// pointer to process security attributes, we don't need to inherit the handle
      NULL, 		// pointer to thread security attributes
      true,  		// handle inheritance flag
      0,  		   // creation flags
      NULL, 		// pointer to new environment block
      NULL, 		// pointer to current directory name
     &sui,   		// pointer to STARTUPINFO
     &pi 			// pointer to PROCESS_INFORMATION
   )))
   {
      output->Add("CreateProcess Error: "+GetLastErrorStr());
      return false;
   }
   CloseHandle(pi.hThread);

   DWORD bt;
   int ms=100;
   //bool ok=true;
   timeout=false;
   time_t marktime=time(NULL);
   while (time(NULL)<marktime+30)
   {
      Application->ProcessMessages();
      // if this wait fails go straight to errorstr
      if ((exitwait=WaitForSingleObject(pi.hProcess,ms))!=WAIT_FAILED)
      {
         if (progressbar!=NULL)
         {
            progressbar->Position += (WORD)1;
            if (progressbar->Position>100) progressbar->Position = 20;
         }
         if (cancel!=NULL && *cancel)
         {
            CloseHandle(pi.hProcess);
            break;
         }
         Application->ProcessMessages();
         while (PeekNamedPipe(hReadPipe,NULL,NULL,NULL,&bt,NULL) && bt)
         {
            Application->ProcessMessages();
            readfile(hReadPipe);
         }
         marktime = time(NULL);
      }
      else
      {
         if (exitwait==0) output->Add("WaitForSingle Error: 0 ");
         if (exitwait==WAIT_FAILED)
            output->Add("WaitForSingle Error: "+GetLastErrorStr());
         break;
      }
      if ((exitproc=GetExitCodeProcess(pi.hProcess,&exitcode))==0)
         output->Add("GetExitCode Error: "+GetLastErrorStr());

      if (exitwait!=WAIT_TIMEOUT) break;
   }
//timeout=time(NULL)>=marktime+30;  // maybe this should be up a line
   return MAKELONG(exitwait,exitcode);  // should be 0
}
//---------------------------------------------------------------------------

